// OKTest.cpp : Defines the entry point for the console application.
//

//#include "stdafx.h"

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <windows.h>
#include "BGateL.h"
#include "..\ioctl.h"

int m_nBlueGateID=-1;
BOOL fBoardID=TRUE;

int FindBlueGate()
{
	return BlueGateL_Find();
}

unsigned int OpenBlueGate(unsigned int id)
{
	m_nBlueGateID=-1;

	if(BlueGateL_Open(id)==FALSE)
	{
		printf("No device : %d\n",id);
		return FALSE;
	}

	printf("Initialize BlueGate-L [%d] ....OK.\n",id);

	m_nBlueGateID = id;

	return TRUE;
}

void CloseBlueGate()
{
	if(m_nBlueGateID==-1)
		return;

	printf("Close BlueGate-L [%d] ....OK.\n",m_nBlueGateID);

	BlueGateL_Close(m_nBlueGateID);

	m_nBlueGateID = -1;
}

BOOL DoRegTest(void)
{
	ULONG data;
	int i;

	BlueGateL_WriteMem(m_nBlueGateID,BLUEGATEL_PWM,0);
	data = BlueGateL_ReadMem(m_nBlueGateID,BLUEGATEL_PWM);
	if(data!=0)
	{
		if(data==0x3ffffff)
		{
			printf("[NG] : Check EPLD download or LA[11]-LA[8]\n");
			return FALSE;
		}
		printf("[NG] : Check LD[27]-LD[0] ( Test : 0000000, Result : %8lx )\n", data);
		return FALSE;
	}

	BlueGateL_WriteMem(m_nBlueGateID,BLUEGATEL_PWM,0x3ffffff);
	data = BlueGateL_ReadMem(m_nBlueGateID,BLUEGATEL_PWM);
	if(data!=0x3ffffff)
	{
		if(data==0)
		{
			printf("[NG] : Check EPLD download or LA[11]-LA[8]\n");
			return FALSE;
		}
		printf("[NG] : Check LD[27]-LD[0] ( Test : ffffff, Result : %8lx )\n", data);
		return FALSE;
	}
	BlueGateL_WriteMem(m_nBlueGateID,BLUEGATEL_PWM,0);

	for(i=0;i<27;i++)
	{
		BlueGateL_WriteMem(m_nBlueGateID,BLUEGATEL_PWM,1<<i);
		data = BlueGateL_ReadMem(m_nBlueGateID,BLUEGATEL_PWM);
		if(data!=(ULONG)(1<<i))
		{
			printf("[NG] :  Check LD[%d] ( Test Pattern : %08x, Result : %08x )\n", i, (ULONG)1<<i, data);
			return FALSE;
		}
	}

	return TRUE;
}

BOOL DoIoTest(void)
{
	ULONG data;
	int i;

	BlueGateL_EnableOut(m_nBlueGateID,TRUE);

	for(i=0;i<8;i++)
	{
		BlueGateL_WriteOut(m_nBlueGateID,1<<i);
		Sleep(10);
		data = BlueGateL_ReadIn(m_nBlueGateID);
		if( data != (ULONG)(1<<i))
		{
			printf("[NG] :  Check IN[%d] and OUT[%d] ( Test Pattern : %06x, Result : %08x )\n", i, i, (ULONG)1<<i, data);
			return FALSE;
		}
	}

	return TRUE;
}
void DoPWMTest(void)
{
	printf(" Check LEDs...\n");
	for(int i=1;i<4;i++)
	{
		BlueGateL_WritePWM(m_nBlueGateID,i,0xff);
		BlueGateL_EnablePWM(m_nBlueGateID,i,TRUE);
		Sleep(1000);
		BlueGateL_EnablePWM(m_nBlueGateID,i,FALSE);
		Sleep(10);
	}
}

int main(int argc, char* argv[])
{
    int     i, f_read=0;
    clock_t startClock;
    clock_t endClock;
	//unsigned char *file_buf;
	unsigned long cnt=0;

    printf( "BlueGate-L OK Test Program \n");
	printf( "by Younjae Kim ( NextEye ) [2001.2]\n");

	i=0;
/*	if(argc==1)
		i=0;
	if(argc>1)
	{
		i= (int)(argv[1][0] - '0');
		if( argc > 2 || i<0 || i>4 )
		{
			printf("ERROR : Invalid card number !!!\n\n");
			printf("OKTest [n]\n");
			printf(" n : card number to test \n");
			return 0;
		}
	}*/

	/* Initialize PCI9052 */
	int bgnum;
	bgnum=FindBlueGate();
	if(bgnum==0)
	{
		printf("Found no card");
		return ( 0 );
	}

	printf("%d cards are found\n", bgnum);
	for(i=0;i<bgnum;i++)
	{
		printf("<<-----  BlueGate-L card [%d]  ----->>\n",i);

		OpenBlueGate(i);

		/* Execute the XSVF in the file */
		startClock  = clock();

		if(DoRegTest())
			if(DoIoTest())
				DoPWMTest();
		/*while(1)
		{
			BlueGateL_EnablePWM(m_nBlueGateID,1,TRUE);
			for(int j=0;j<16;j++)
			{
				BlueGateL_WritePWM(m_nBlueGateID,1,j*0x10);
				Sleep(1000);
			}
			for(j=15;j>=0;j--)
			{
				BlueGateL_WritePWM(m_nBlueGateID,1,j*0x10);
				Sleep(1000);
			}
			BlueGateL_EnablePWM(m_nBlueGateID,1,FALSE);
			Sleep(3000);
		}*/

		endClock    = clock();
		printf( "Execution Time = %.3f seconds\n",
			(((double)(endClock - startClock))/CLOCKS_PER_SEC) );

		CloseBlueGate();
	}

	return 0;
}
