#ifndef __BLUEGATE_L__
#define __BLUEGATE_L__

#ifdef __cplusplus
extern "C"
{
#endif

/* DLL support */
#ifndef ___EXPORT
	#define ___EXPORT
#endif

/******************************************************************************/
/*     classic BlueGate functions                                             */
/*     by prof. cho                                                           */
___EXPORT BOOL BlueGateL_Open(int unit);
___EXPORT void BlueGateL_Close(int unit);
___EXPORT void BlueGateL_CloseAll();
___EXPORT int BlueGateL_Find();

___EXPORT void BlueGateL_EnableIntr(int unit,BOOL enable);
___EXPORT ULONG BlueGateL_WaitForIntr(int unit,ULONG timeout_msec,ULONG *input);
___EXPORT ULONG BlueGateL_ReadIo(int unit);
___EXPORT ULONG BlueGateL_ReadIntrStatus(int unit);
___EXPORT void BlueGateL_SetIntrMask(int unit,ULONG mask);
___EXPORT void BlueGateL_ClearIntrStatus(int unit);
___EXPORT ULONG BlueGateL_WriteIo(int unit,ULONG data);
___EXPORT BOOL BlueGateL_CreateThread(int unit,HWND hwnd,UINT msg);
___EXPORT void BlueGateL_CloseThread(int unit);

___EXPORT void BlueGateL_Delay(ULONG microsec);

/******************************************************************************/
/*     extended BlueGate functions                                            */
/*     by Younjae Kim (2001/01/04)                                            */
___EXPORT int BlueGateL_ReadId(int unit);
___EXPORT ULONG BlueGateL_ReadIn(int unit);
___EXPORT ULONG BlueGateL_ReadOut(int unit);
___EXPORT ULONG BlueGateL_WriteOut(int unit,ULONG data);
___EXPORT void  BlueGateL_EnableOut(int unit,BOOL enable);


/******************************************************************************/
/*     extended BlueGate-L functions                                            */
/*     by Younjae Kim (2001/01/04)                                            */
___EXPORT ULONG BlueGateL_WritePWM(int unit, int ch, ULONG data);
___EXPORT ULONG BlueGateL_ReadPWM(int unit, int ch);
___EXPORT void  BlueGateL_EnablePWM(int unit, int ch, BOOL enable);
___EXPORT void  BlueGateL_EnableExtTrig(int unit,BOOL enable);


/******************************************************************************/
/*     Hidden BlueGate functions (don't include in public version )           */
/*     by Younjae Kim (2001/01/04)                                            */
___EXPORT ULONG BlueGateL_ReadBoardId(int unit);
___EXPORT ULONG BlueGateL_ReadRegister(int unit,int byteoffset);
___EXPORT void BlueGateL_WriteRegister(int unit,int byteoffset,ULONG value);
___EXPORT ULONG BlueGateL_ReadMem(int unit,ULONG addr);
___EXPORT void BlueGateL_WriteMem(int unit,ULONG addr,ULONG data);
___EXPORT ULONG *BlueGateL_GetRegisterPtr(int unit);
___EXPORT ULONG *BlueGateL_GetLocal0Ptr(int unit);

#ifdef __cplusplus
}
#endif

#endif