//
// $Header: /devl/xcs/repo/env/Jobs/JTag/basjdrv/export/Attic/basjdrvif.h,v 1.1.2.1 1998/10/13 19:21:10 neilj Exp $
//
// Parallel Port Driver Interface Functions
// For use with WinDrvr standard driver/vxd for WinNT/95
//
#ifndef BASJDRVIF_H
#define BASJDRVIF_H

#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#ifdef _MSC_VER
    #pragma warning( disable: 4201 )
#endif
#include <winioctl.h>
#ifdef _MSC_VER
    #pragma warning( default: 4201 )
#endif

#include "windrvr.h"


// Constants

//----------------------------------------------------------------------*/
// Base memory address containing the installed port IO addresses */
//----------------------------------------------------------------------*/

#define LPT_BASE_MEM_ADDR      0x0408;

//----------------------------------------------------------------------*/
// Only legal port IO address on PC98 machine  */
//----------------------------------------------------------------------*/

#define PC98_BASE_IO_ADDR  0x40;

//----------------------------------------------------------------------*/
// IO Port offsets from base for parallel port functions
//----------------------------------------------------------------------*/

#define DATA_OFFSET    (0*io_increment)
#define STATUS_OFFSET  (1*io_increment)
#define CONTROL_OFFSET (2*io_increment)

//----------------------------------------------------------------------*/
// Base driver class
//----------------------------------------------------------------------*/

class jdriver {
private:
  HANDLE hWD;
  DWORD io_increment;
  DWORD jcab_base_port;
  DWORD max_write_size;
  DWORD m_dwBufferSize;
  WD_TRANSFER *m_transfer;

public:
  
  jdriver();
  ~jdriver();
  int     open();
  void    close();

  int     GetParallelPorts( DWORD port_index );
  BOOLEAN WRTransfer( LPBYTE pOutBuf, LPBYTE pInBuf, DWORD dwSize );
  BYTE    ReadByte( DWORD dwIOAddr );
  BYTE    WriteByte( DWORD dwIOAddr, BYTE bData );

  DWORD   inline GetStatusPort() { return( jcab_base_port + STATUS_OFFSET ); }
  DWORD   inline GetDataPort() { return( jcab_base_port + DATA_OFFSET ); }
  DWORD   inline GetControlPort() { return( jcab_base_port + CONTROL_OFFSET ); }

};

#endif



